#include <windows.h>

#define EXPORT                /* global (project-scope)                       */
#define TRANSIENT     auto    /* automatic (function-scope)                   */
#define MODULE        static  /* external static (file-scope)                 */
#define PERSIST       static  /* internal static (function-scope)             */
#define FAST          static  /* internal static (function-scope)             */
#define DISCARD       (void)  /* discarded return values */
#define elif          else if
#define acase         break; case
#define adefault      break; default
#define EOS           0       // end of string

typedef signed char         FLAG;   // 8-bit signed quantity (replaces BOOL)
typedef signed char         SBYTE;  // 8-bit signed quantity (replaces Amiga BYTE)
typedef signed short        SWORD;  // 16-bit signed quantity (replaces Amiga WORD)
typedef signed long         SLONG;  // 32-bit signed quantity (same as LONG)

typedef unsigned long       COLOUR;     // 32-bit unsigned
typedef unsigned short      SCANCODE;   // 16-bit unsigned

#define EWINIT
#define EWUNINIT

#define LLL(a, b) GetCatalogStr(CatalogPtr, a, b)

#define DEFAULTSET          "WormWars.lset"
#define FONTX                  8
#define FONTY                 12
#define SQUAREX               12
#define SQUAREY               12
#define STARTXPIXEL           74
#define STARTYPIXEL           20
#define __inline

#define SCAN_ESCAPE           1
#define SCAN_A1               2 // alphabetic 1
#define SCAN_A2               3 // alphabetic 2
#define SCAN_A3               4 // alphabetic 3
#define SCAN_A4               5 // alphabetic 4
#define SCAN_A5               6 // alphabetic 5
#define SCAN_A6               7 // alphabetic 6
#define SCAN_A7               8 // alphabetic 7
#define SCAN_A8               9 // alphabetic 8
#define SCAN_A9              10 // alphabetic 9
#define SCAN_A0              11 // alphabetic 0
#define SCAN_Q               16
#define SCAN_W               17
#define SCAN_E               18
#define SCAN_R               19
#define SCAN_T               20 // turbo mode on/off
#define SCAN_Y               21
#define SCAN_U               22
#define SCAN_I               23
#define SCAN_O               24
#define SCAN_P               25
#define SCAN_RETURN          28 // alphabetic RETURN
#define SCAN_LCTRL           29
#define SCAN_A               30 // save as...
#define SCAN_S               31 // save
#define SCAN_D               32
#define SCAN_F               33 // effects
#define SCAN_G               34
#define SCAN_H               35
#define SCAN_J               36
#define SCAN_K               37
#define SCAN_L               38
#define SCAN_LSHIFT          42
#define SCAN_Z               44
#define SCAN_X               45
#define SCAN_C               46
#define SCAN_V               47
#define SCAN_B               48
#define SCAN_N               49
#define SCAN_M               50 // music
#define SCAN_SLASH           53
#define SCAN_RSHIFT          54
#define SCAN_NUMERICASTERISK 55 // numeric *
#define SCAN_SPACEBAR        57
#define SCAN_F1              59
#define SCAN_F2              60
#define SCAN_F3              61
#define SCAN_F4              62
#define SCAN_F5              63
#define SCAN_F6              64
#define SCAN_F7              65
#define SCAN_F8              66
#define SCAN_F9              67
#define SCAN_F10             68
#define SCAN_PAUSE           69
#define SCAN_N7              71 // numeric 7
#define SCAN_N8              72 // numeric 8
#define SCAN_N9              73 // numeric 9
#define SCAN_NUMERICMINUS    74 // numeric -
#define SCAN_N4              75 // numeric 4
#define SCAN_N5              76 // numeric 5
#define SCAN_N6              77 // numeric 6
#define SCAN_NUMERICPLUS     78 // numeric +
#define SCAN_N1              79 // numeric 1
#define SCAN_N2              80 // numeric 2
#define SCAN_N3              81 // numeric 3
#define SCAN_N0              82 // numeric 0
#define SCAN_NUMERICDOT      83 // numeric .
#define SCAN_HELP            87 // F11
#define SCAN_F12             88
#define SCAN_ENTER          284 // numeric ENTER
#define SCAN_RCTRL          285
#define SCAN_NUMERICSLASH   309 // numeric /
#define SCAN_UP             328
#define SCAN_PGUP           329
#define SCAN_LEFT           331
#define SCAN_RIGHT          333
#define SCAN_DOWN           336
#define SCAN_PGDN           337

#define BLACK               (RGB(  0,   0,   0))
#define WHITE               (RGB(255, 255, 255))
#define LIGHTGREY           (RGB(160, 160, 160))
#define DARKGREY            (RGB( 32,  32,  32))
#define ORANGE              (RGB(240, 128,  48))
#define PURPLE              (RGB(255,  96, 255))
#define DARKGREEN           (RGB( 48, 144,  48))
#define GREEN               (RGB( 96, 255,  96))
#define DARKRED             (RGB(255,  16,  16))
#define RED                 (RGB(255, 128, 128))
#define DARKBLUE            (RGB( 64,  64, 255))
#define BLUE                (RGB(128, 128, 255))
#define DARKYELLOW          (RGB(160, 128,  48))
#define YELLOW              (RGB(255, 255,  32))
#define MEDIUMGREY          (RGB(128, 128, 128))

/* IBM-PC-ONLY ----------------------------------------------------------

Native Amiga types, emulated identically for Windows */

#define IMPORT              extern  // reference to an external (global-scope)
typedef unsigned char       UBYTE;  // 8-bit unsigned quantity
typedef unsigned short      UWORD;  // 16-bit unsigned quantity
typedef void*               APTR;   // 32-bit untyped pointer
typedef unsigned char       TEXT;   // 8-bit unsigned character

// Native Amiga types, emulated differently for Windows

typedef TEXT*               STRPTR; /* string pointer (NULL-terminated)
                                       (pointer to TEXT)

IBM-PC ONLY ------------------------------------------------------------ */

#define USR_NOTIFYICON (WM_USER + 1)
#define IDK_F12                0

#define UISF_HIDEACCEL         2
#define UIS_CLEAR              2
#define WM_CHANGEUISTATE   0x127

#define HISCOREHEADX         596
#define HISCOREHEADY         107
#define HISCOREDISTANCE       21
#define TITLESCREENX          85
#define TITLESCREENY          92
#define INTROTEXTX           100
#define INTROTILEX            80
#define SOUND_NONE             0
#define SOUND_MUSIC            1
#define SOUND_FX               2

#define PARAM2SCANCODE(x) ((x & 0x01FF0000) >> 16)

EXPORT struct Chunk
{   LONG          ckID;
    LONG          ckSize;
    LONG          ckType;
    void*         ckData;
    struct Chunk* ckNext;
};
